"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isGlob = require("is-glob");
var isValidPath = require("is-valid-path");
var glob = require("glob");
var graphql_tools_1 = require("graphql-tools");
var fs_1 = require("fs");
var graphql_import_1 = require("graphql-import");
var path = require("path");
var fs = require("fs");
var SchemaFromTypedefs = /** @class */ (function () {
    function SchemaFromTypedefs() {
    }
    SchemaFromTypedefs.prototype.canHandle = function (globPath) {
        return isGlob(globPath) || (isValidPath(globPath) && globPath.endsWith('.graphql'));
    };
    SchemaFromTypedefs.prototype.handle = function (globPath, cliOptions) {
        var globFiles = glob.sync(globPath, { cwd: process.cwd() });
        if (!globFiles || globFiles.length === 0) {
            throw new Error("Unable to find matching files for glob: " + globPath + "!");
        }
        var mergeLogic = function (arr) { return arr; };
        if ('mergeSchema' in cliOptions) {
            var patternArr = cliOptions.mergeSchema.split('#');
            var mergeModuleName = patternArr[0];
            var mergeFunctionName = patternArr[1];
            if (!mergeModuleName || !mergeFunctionName) {
                throw new Error('You have to specify your merge logic with `mergeSchema` option; <mergeModule#mergeFn>');
            }
            var localFilePath = path.resolve(process.cwd(), mergeModuleName);
            var localFileExists = fs.existsSync(localFilePath);
            var mergeModule = require(localFileExists ? localFilePath : mergeModuleName);
            if (!(mergeFunctionName in mergeModule)) {
                throw new Error(mergeFunctionName + " couldn't be found in " + mergeModule);
            }
            mergeLogic = mergeModule[mergeFunctionName];
        }
        var typeDefs = globFiles.length > 1
            ? mergeLogic(globFiles.map(function (filePath) { return fs_1.readFileSync(filePath, 'utf-8'); }))
            : graphql_import_1.importSchema(globFiles[0]);
        return graphql_tools_1.makeExecutableSchema({
            typeDefs: typeDefs,
            allowUndefinedInResolve: true,
            resolvers: {},
            resolverValidationOptions: { requireResolversForResolveType: false }
        });
    };
    return SchemaFromTypedefs;
}());
exports.SchemaFromTypedefs = SchemaFromTypedefs;
//# sourceMappingURL=schema-from-typedefs.js.map